#property link ""

#property strict
#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 DodgerBlue
#property indicator_color2 MediumVioletRed
#property indicator_color3 MediumVioletRed
#property strict

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame = 240;
extern int CCIPeriod = 14;
extern int RSIPeriod = 9;

//
//
//
//
//

double   Trend[];
double   TrendDoA[];
double   TrendDoB[];
double   Direction[];
string   IndicatorFileName;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//



int OnInit()
  {
//--- indicator buffers mapping
   for (int i=0; i<indicator_buffers; i++) SetIndexStyle(i,DRAW_LINE,0,1);
   IndicatorBuffers(4);
      SetIndexBuffer(0, Trend);
      SetIndexBuffer(1, TrendDoA);
      SetIndexBuffer(2, TrendDoB);
      SetIndexBuffer(3, Direction);
         SetIndexLabel(0,"SuperTrend");
         SetIndexLabel(1,"SuperTrend");
         SetIndexLabel(2,"SuperTrend");
        
   TimeFrame = MathMax(TimeFrame,_Period);
   IndicatorFileName = WindowExpertName();
   IndicatorShortName("B Trend "+TimeFrameToString(TimeFrame));    
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   int counted_bars = IndicatorCounted();
   if (counted_bars < 0) return(-1);
   if (counted_bars>0) counted_bars--;
      int limit = MathMin(Bars-counted_bars,Bars-1);

      if (TimeFrame != Period())
      {
         limit = MathMax(limit,TimeFrame/Period());
         if (Direction[limit] == -1) CleanPoint(limit,TrendDoA,TrendDoB);
            for(int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,TimeFrame,Time[i]);
               TrendDoA[i]  = EMPTY_VALUE;
               TrendDoB[i]  = EMPTY_VALUE;
               Trend[i]     = iCustom(NULL,TimeFrame,IndicatorFileName,0,CCIPeriod,RSIPeriod,0,y);
               Direction[i] = iCustom(NULL,TimeFrame,IndicatorFileName,0,CCIPeriod,RSIPeriod,3,y);
                  if (Direction[i]==-1) PlotPoint(i,TrendDoA,TrendDoB,Trend);
            }
         return(0);         
      }

   //
   //
   //
   //
   //
      
   if (Direction[limit] == -1) CleanPoint(limit,TrendDoA,TrendDoB);
   for(int i = limit; i >= 0; i--)
   {
      double cciTrend = iCCI(NULL, 0, CCIPeriod, PRICE_TYPICAL, i);
      double rsiTrend = iRSI(NULL, 0, RSIPeriod, PRICE_TYPICAL, i);
         
         //
         //
         //
         //
         //
         
         TrendDoA[i]  = EMPTY_VALUE;
         TrendDoB[i]  = EMPTY_VALUE;
         Trend[i]     = (i<Bars-1) ? Trend[i+1] : Close[i];
         Direction[i] = (i<Bars-1) ? Direction[i+1] : 0;
         if (i<Bars-1)
         {
            if (cciTrend > 0 && rsiTrend > 50) { Trend[i] = MathMax(Low[i]  - iATR(NULL, 0, 5, i),Trend[i+1]==EMPTY_VALUE?Low[i] :Trend[i+1]); Direction[i] =  1; }
            if (cciTrend < 0 && rsiTrend < 50) { Trend[i] = MathMin(High[i] + iATR(NULL, 0, 5, i),Trend[i+1]==EMPTY_VALUE?High[i]:Trend[i+1]); Direction[i] = -1; }
            if (Direction[i]==-1) PlotPoint(i,TrendDoA,TrendDoB,Trend);
         }            
   }
   return(rates_total);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
} 

//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+

string TimeFrameToString(int tf)
{
   string tfs="";
   if (Period()!=tf)
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN1";
   }
   return(tfs);
}